using Avalonia.Controls;
using Avalonia.Controls.Primitives;
using Avalonia.Interactivity;
using Avalonia.Media.Imaging;
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Net.NetworkInformation;
using System.Runtime.Intrinsics.Arm;
using System.Text;
using Tmds.DBus.Protocol;
using static System.Runtime.InteropServices.JavaScript.JSType;


namespace AvaloniaApplication2
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        public void Button_Click1(object sender, RoutedEventArgs e)
        {
            if (dateT.SelectedDate == null)
            {
                message10.Text = " !";
                return;
            }

            string date1 = dateT.SelectedDate.ToString();
            DateTime birthdate = DateTime.Parse(date1);
            DateTime today = DateTime.Today;

            if (birthdate > today)
            {
                message10.Text = "   !";
                return;
            }

            int age_y = today.Year - birthdate.Year;
            int age_m = today.Month - birthdate.Month;
            int age_d = today.Day - birthdate.Day;

            if (age_d < 0)
            {
                age_m--;
                age_d += DateTime.DaysInMonth(today.Year, today.Month);
            }

            if (age_m < 0)
            {
                age_y--;
                age_m += 12;
            }

            message1.Text = $" - {age_y}. ";
            message2.Text = $" - {age_m}";
            message3.Text = $" - { age_d}."; 
            message4.Text = " : " + birthdate.DayOfWeek;

            int count = 0;
            for (DateTime date = birthdate; date <= today; date = date.AddYears(1))
            {
                if (date.DayOfWeek == birthdate.DayOfWeek)
                {
                    count++;
                }
            }
            message5.Text = " : " + (age_m < today.Month ? count - 1 : count) + ".";

            int startYear = birthdate.Year;
            int endYear = today.Year;
            string vsk = " : " + string.Join(" ", Enumerable.Range(startYear, endYear - startYear + 1).Where(VSK));
            message7.Text = vsk;
        }

        static bool VSK(int year) => (year % 4 == 0 && year % 100 != 0) || (year % 400 == 0);

        public void Radio1(object sender, RoutedEventArgs e)
        {

            string date1 = dateT.SelectedDate.ToString();
            DateTime birthdate = DateTime.Parse(date1);
            DateTime today = DateTime.Today;
            int age_yy = birthdate.Year;
            int age_mm = birthdate.Month;
            int age_dd = birthdate.Day;
            string path13 = "zodiak.png";

            if (age_dd >= 21 && age_mm == 3 || age_dd <= 20 && age_mm == 4)
            {
                message6.Text = "   - .";
                pic.Source = new Bitmap(path13);

            }
            else if (age_dd >= 21 && age_mm == 4 || age_dd <= 21 && age_mm == 5)
            {
                message6.Text = "   - .";
                pic.Source = new Bitmap(path13);
            }
            else if (age_dd >= 22 && age_mm == 5 || age_dd <= 21 && age_mm == 6)
            {
                message6.Text = "   - .";
                pic.Source = new Bitmap(path13);
            }
            else if (age_dd >= 22 && age_mm == 6 || age_dd <= 23 && age_mm == 7)
            {
                message6.Text = "   - .";
                pic.Source = new Bitmap(path13);
            }
            else if (age_dd >= 24 && age_mm == 7 || age_dd <= 23 && age_mm == 8)
            {
                message6.Text = "   - .";
                pic.Source = new Bitmap(path13);
            }
            else if (age_dd >= 24 && age_mm == 8 || age_dd <= 23 && age_mm == 9)
            {
                message6.Text = "   - .";
                pic.Source = new Bitmap(path13);
            }
            else if (age_dd >= 24 && age_mm == 9 || age_dd <= 23 && age_mm == 10)
            {
                message6.Text = "   - .";
                pic.Source = new Bitmap(path13);
            }
            else if (age_dd >= 24 && age_mm == 10 || age_dd <= 22 && age_mm == 11)
            {
                message6.Text = "   - .";
                pic.Source = new Bitmap(path13);
            }
            else if (age_dd >= 23 && age_mm == 11 || age_dd <= 21 && age_mm == 12)
            {
                message6.Text = "   - .";
                pic.Source = new Bitmap(path13);
            }
            else if (age_dd >= 22 && age_mm == 12 || age_dd <= 20 && age_mm == 1)
            {
                message6.Text = "   - .";
                pic.Source = new Bitmap(path13);
            }
            else if (age_dd >= 21 && age_mm == 1 || age_dd <= 19 && age_mm == 2)
            {
                message6.Text = "   - .";
                pic.Source = new Bitmap(path13);
            }
            else
            {
                message6.Text = "   - .";
                pic.Source = new Bitmap(path13);
            }
        }

        public void Radio2(object sender, RoutedEventArgs e)
        {
            string path1 = "pig.webp";
            string path2 = "dog.jpg";
            string path3 = "drakon.webp";
            string path4 = "koza.webp";
            string path5 = "loshadka.webp";
            string path6 = "petux.webp";
            string path7 = "monkey.jpg";
            string path8 = "rabbit.jpg";
            string path9 = "mouse.jpg";
            string path10 = "zmeya.jpg";
            string path11 = "tiger.jpg";
            string path12 = "buk.png";
            string date1 = dateT.SelectedDate.ToString();
            DateTime birthdate = DateTime.Parse(date1);
            DateTime today = DateTime.Today;
            int age_yy = birthdate.Year;
            if (age_yy == 1899 || age_yy == 1911 || age_yy == 1923 || age_yy == 1935 || age_yy == 1947 || age_yy == 1959 || age_yy == 1971 || age_yy == 1983 || age_yy == 1995 || age_yy == 2007 || age_yy == 2019 || age_yy == 2031)
            {
                message6.Text = "    .";
                pic.Source = new Bitmap(path1);
            }
            if (age_yy == 1900 || age_yy == 1912 || age_yy == 1924 || age_yy == 1936 || age_yy == 1948 || age_yy == 1960 || age_yy == 1972 || age_yy == 1984 || age_yy == 1996 || age_yy == 2008 || age_yy == 2020 || age_yy == 2032)
            {
                message6.Text = "    .";
                pic.Source = new Bitmap(path9);
            }
            if (age_yy == 1901 || age_yy == 1913 || age_yy == 1925 || age_yy == 1937 || age_yy == 1949 || age_yy == 1961 || age_yy == 1973 || age_yy == 1985 || age_yy == 1997 || age_yy == 2009 || age_yy == 2021 || age_yy == 2033)
            {
                message6.Text = "    .";
                pic.Source = new Bitmap(path12);
            }
            if (age_yy == 1902 || age_yy == 1914 || age_yy == 1926 || age_yy == 1938 || age_yy == 1950 || age_yy == 1962 || age_yy == 1974 || age_yy == 1986 || age_yy == 1998 || age_yy == 2010 || age_yy == 2022 || age_yy == 2034)
            {
                message6.Text = "    .";
                pic.Source = new Bitmap(path11);
            }
            if (age_yy == 1903 || age_yy == 1915 || age_yy == 1927 || age_yy == 1939 || age_yy == 1951 || age_yy == 1963 || age_yy == 1975 || age_yy == 1987 || age_yy == 1999 || age_yy == 2011 || age_yy == 2023 || age_yy == 2035)
            {
                message6.Text = "    .";
                pic.Source = new Bitmap(path8);
            }
            if (age_yy == 1904 || age_yy == 1916 || age_yy == 1928 || age_yy == 1940 || age_yy == 1952 || age_yy == 1964 || age_yy == 1976 || age_yy == 1988 || age_yy == 2000 || age_yy == 2012 || age_yy == 2024 || age_yy == 2036)
            {
                message6.Text = "    .";
                pic.Source = new Bitmap(path3);
            }
            if (age_yy == 1905 || age_yy == 1917 || age_yy == 1929 || age_yy == 1941 || age_yy == 1953 || age_yy == 1965 || age_yy == 1977 || age_yy == 1989 || age_yy == 2001 || age_yy == 2013 || age_yy == 2025 || age_yy == 2037)
            {
                message6.Text = "    .";
                pic.Source = new Bitmap(path10);
            }
            if (age_yy == 1906 || age_yy == 1918 || age_yy == 1930 || age_yy == 1942 || age_yy == 1954 || age_yy == 1966 || age_yy == 1978 || age_yy == 1990 || age_yy == 2002 || age_yy == 2014 || age_yy == 2026 || age_yy == 2038)
            {
                message6.Text = "    .";
                pic.Source = new Bitmap(path5);
            }
            if (age_yy == 1907 || age_yy == 1919 || age_yy == 1931 || age_yy == 1943 || age_yy == 1955 || age_yy == 1967 || age_yy == 1979 || age_yy == 1991 || age_yy == 2003 || age_yy == 2015 || age_yy == 2027 || age_yy == 2039)
            {
                message6.Text = "    .";
                pic.Source = new Bitmap(path4);
            }
            if (age_yy == 1908 || age_yy == 1920 || age_yy == 1932 || age_yy == 1944 || age_yy == 1956 || age_yy == 1968 || age_yy == 1980 || age_yy == 1992 || age_yy == 2004 || age_yy == 2016 || age_yy == 2028 || age_yy == 2040)
            {
                message6.Text = "    .";
                pic.Source = new Bitmap(path7);
            }
            if (age_yy == 1909 || age_yy == 1921 || age_yy == 1933 || age_yy == 1945 || age_yy == 1957 || age_yy == 1969 || age_yy == 1981 || age_yy == 1993 || age_yy == 2005 || age_yy == 2017 || age_yy == 2029 || age_yy == 2041)
            {
                message6.Text = "    .";
                pic.Source = new Bitmap(path6);
            }
            if (age_yy == 1910 || age_yy == 1922 || age_yy == 1934 || age_yy == 1946 || age_yy == 1958 || age_yy == 1970 || age_yy == 1982 || age_yy == 1994 || age_yy == 2006 || age_yy == 2018 || age_yy == 2030 || age_yy == 2042)
            {
                message6.Text = "    .";
                pic.Source = new Bitmap(path2);
            }
        }

        public void Button_Click2(object sender, RoutedEventArgs e)
        {
            string inputPath = "data.csv";
            string outputPath = "data2.csv";

            var lines = new List<string>();

            try
            {
                using (StreamReader reader = new StreamReader(inputPath, Encoding.UTF8))
                {
                    string line;
                    while ((line = reader.ReadLine()) != null)
                    {
                        lines.Add(line);
                    }
                }
            }
            catch (Exception ex)
            {
                message10.Text = $"   : {ex.Message}";
                return;
            }

            var outputLines = new List<string>();

            if (lines.Count > 0)
            {
                var headers = lines[0] + "         ";
                outputLines.Add(headers);
            }

            for (int i = 1; i < lines.Count; i++)
            {
                var line = lines[i];
                var columns = line.Split(';');

                if (columns.Length < 3) continue;

                var day = columns[0].Trim();
                var month = columns[1].Trim();
                var year = columns[2].Trim();

                string zodiacSign = "";
                string chineseZodiac = "";
                string error = "";

                if (ParseDate(day, month, year, out DateTime birthdate, out error))
                {
                    zodiacSign = Zodiac(birthdate);
                    chineseZodiac = Goroscop(birthdate.Year);
                }
                else
                {
                    error = ": " + error;
                }

                outputLines.Add($"{day};{month};{year};{zodiacSign};{chineseZodiac};{error}");
            }

            try
            {
                using (StreamWriter writer = new StreamWriter(outputPath, false, Encoding.UTF8))
                {
                    foreach (var outputLine in outputLines)
                    {
                        writer.WriteLine(outputLine);
                    }
                }
                message10.Text = " .     .";
            }
            catch (Exception ex)
            {
                message10.Text = $": {ex.Message}";
            }
        }

        public bool ParseDate(string day, string month, string year, out DateTime birthdate, out string error)
        {
            birthdate = default;
            error = "";
            int dayNum = 0, monthNum = 0, yearNum = 0;

            if (ConvertToInt(day, out dayNum) && dayNum >= 1 && dayNum <= 31)
            {
                
            }
            else if (ConvertToDecimal(day, out decimal decimalDay))
            {
                dayNum = (int)(decimalDay > 0.5m ? Math.Ceiling(decimalDay) : Math.Floor(decimalDay));
                if (dayNum < 1 || dayNum > 31) error += " ; ";
            }
            else
            {
                error += " ; ";
            }

            if (ConvertMonth(month, out monthNum) || (ConvertToInt(month, out monthNum) && monthNum >= 1 && monthNum <= 12))
            {
                
            }
            else
            {
                error += " ; ";
            }

         
            if (ConvertToInt(year, out yearNum) && yearNum >= 1900 && yearNum <= DateTime.Now.Year)
            {
                
            }
            else
            {
                error += " ; ";
            }

            if (yearNum > 0)
            {
                int validDay = dayNum > 0 ? dayNum : 1; 
                int validMonth = monthNum > 0 ? monthNum : 1; 

                try
                {
                    birthdate = new DateTime(yearNum, validMonth, validDay);
                    return true;
                }
                catch
                {
                    error += "  ; ";
                }
            }

            return false;
        }
        private bool ConvertToDecimal(string input, out decimal result)
        {
            return decimal.TryParse(input, out result);
        }

        private bool ConvertMonth(string month, out int monthNum)
        {
            monthNum = 0;
            month = month.Trim().ToLower();

            var months = new Dictionary<string, int>
    {
        { "", 1 },
        { "", 2 },
        { "", 3 },
        { "", 4 },
        { "", 5 },
        { "", 6 },
        { "", 7 },
        { "", 8 },
        { "", 9 },
        { "", 10 },
        { "", 11 },
        { "", 12 }
    };

            return months.TryGetValue(month, out monthNum);
        }

        private bool ConvertToInt(string value, out int result)
        {
            result = 0;

            value = value.Trim();

            if (int.TryParse(value, out result))
            {
                return true;
            }

            var wordsToNumbers = new Dictionary<string, int>
                {
        { "", 1 },
        { "", 2 },
        { "", 3 },
        { "", 4 },
        { "", 5 },
        { "", 6 },
        { "", 7 },
        { "", 8 },
        { "", 9 },
        { "", 10 },
        { "", 11 },
        { "", 12 }
    };


            if (wordsToNumbers.TryGetValue(value.ToLower(), out result))
            {
                return true;
            }

            if (double.TryParse(value, NumberStyles.Any, CultureInfo.InvariantCulture, out double doubleValue))
            {
                result = (int)Math.Round(doubleValue);
                return true;
            }

            return false;
        }


        public string Zodiac(DateTime birthdate)
        {
            int day = birthdate.Day;
            int month = birthdate.Month;

            if (month == 3 && day >= 21 || month == 4 && day <= 20) return "";
            if (month == 4 && day >= 21 || month == 5 && day <= 21) return "";
            if (month == 5 && day >= 22 || month == 6 && day <= 21) return "";
            if (month == 6 && day >= 22 || month == 7 && day <= 23) return "";
            if (month == 7 && day >= 24 || month == 8 && day <= 23) return "";
            if (month == 8 && day >= 24 || month == 9 && day <= 23) return "";
            if (month == 9 && day >= 24 || month == 10 && day <= 23) return "";
            if (month == 10 && day >= 24 || month == 11 && day <= 22) return "";
            if (month == 11 && day >= 23 || month == 12 && day <= 21) return "";
            if (month == 12 && day >= 22 || month == 1 && day <= 20) return "";
            if (month == 1 && day >= 21 || month == 2 && day <= 19) return "";
            if (month == 2 && day >= 20 || month == 3 && day <= 20) return "";

            return "";
        }

        public string Goroscop(int year)
        {
            string[] animals = { "", "", "", "", "", "", "", "", "", "", "", "" };
            return animals[year % 12];
        }
    }
}

